(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    427577,      13154]
NotebookOptionsPosition[    423722,      13043]
NotebookOutlinePosition[    424058,      13058]
CellTagsIndexPosition[    424015,      13055]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", "Susyno`"}]], "Input",
 CellChangeTimes->{{3.56794462702582*^9, 3.567944629300948*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Version: 1.1 ; Author: Renato Fonseca\\nFor help, use the \
\"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Susyno Tutorial\"\>", True->
      StyleBox["\<\"Susyno Tutorial\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Link",
     ButtonData->"paclet:Susyno/tutorial/SusynoTutorial",
     ButtonNote->"paclet:Susyno/tutorial/SusynoTutorial"],
    Annotation[#, "paclet:Susyno/tutorial/SusynoTutorial", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" and the built-in documentation.\"\>"}],
  SequenceForm["Version: 1.1 ; Author: Renato Fonseca\nFor help, use the ", 
   Hyperlink["Susyno Tutorial", "paclet:Susyno/tutorial/SusynoTutorial"], 
   " and the built-in documentation."],
  Editable->False]], "Print",
 CellChangeTimes->{3.56794462990432*^9, 3.567944674548642*^9, 
  3.567944730077467*^9, 3.567944900017126*^9, 3.567945302971434*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m_", ",", "n_"}], "]"}], 
   ":=", 
   RowBox[{"Y", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";", " ", 
  RowBox[{
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m_", ",", "n_"}], "]"}], 
   ":=", 
   RowBox[{"Y2", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], ";", " ", 
  RowBox[{
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m_", ",", "n_"}], "]"}], 
   ":=", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.56794512104642*^9, 3.567945139475273*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rep16", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"SO10", "->", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"NFlavours", "\[Rule]", "3"}], ",", 
     RowBox[{"DiscreteSym", "\[Rule]", "1"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rep16A", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"SO10", "->", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ",", 
     RowBox[{"NFlavours", "\[Rule]", "3"}], ",", 
     RowBox[{"DiscreteSym", "\[Rule]", "1"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rep10", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SO10", "->", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"NFlavours", "\[Rule]", "1"}], ",", 
      RowBox[{"DiscreteSym", "\[Rule]", "1"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"BetaFunctions1L", "[", 
        RowBox[{"{", 
         RowBox[{"rep10", ",", "rep16", ",", "rep16A"}], "}"}], "]"}], " ", "/.",
        " ", 
       RowBox[{
        RowBox[{"y", "[", 
         RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m_", ",", "n_"}], 
         "]"}], "\[Rule]", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}]}]}], "/.", " ", 
      RowBox[{
       RowBox[{"y", "[", 
        RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m_", ",", "n_"}], 
        "]"}], "\[Rule]", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}]}], " ", "/.", " ", 
     RowBox[{
      RowBox[{"y", "[", 
       RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m_", ",", "n_"}], 
       "]"}], "\[Rule]", "0"}]}], "/.", " ", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m_", ",", "n_"}], 
      "]"}], "\[Rule]", 
     RowBox[{"h", "[", 
      RowBox[{"m", ",", "n"}], "]"}]}]}], "/.", " ", 
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m_", ",", "n_"}], "]"}],
     "\[Rule]", 
    RowBox[{"h2", "[", 
     RowBox[{"m", ",", "n"}], "]"}]}]}], " ", "/.", " ", 
  RowBox[{
   RowBox[{"H", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m_", ",", "n_"}], "]"}], 
   "\[Rule]", "0"}]}]}], "Input",
 CellChangeTimes->{{3.567944768366129*^9, 3.567944805155604*^9}, {
  3.567944854483446*^9, 3.567944888653417*^9}, {3.567945020805987*^9, 
  3.567945045997223*^9}, {3.5679450794530497`*^9, 3.567945103485736*^9}, {
  3.567945215759947*^9, 3.567945247337701*^9}, {3.56794529745578*^9, 
  3.567945328196834*^9}, {3.5679457979502363`*^9, 3.567945809964087*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"g", "[", "1", "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   Susyno`SusyRGEs`g[1]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945810916099*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "11"}], " ", 
  SuperscriptBox[
   RowBox[{"g", "[", "1", "]"}], "3"]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458109567633`*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945810957635*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"M", "[", "1", "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   Susyno`SusyRGEs`M[1]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458112995167`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "22"}], " ", 
  SuperscriptBox[
   RowBox[{"g", "[", "1", "]"}], "2"], " ", 
  RowBox[{"M", "[", "1", "]"}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.56794581134077*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945811341763*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`y[1, 2, 2, 1, Susyno`LieGroups`j, Susyno`LieGroups`k]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945811807651*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["63", "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945811852333*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945811853262*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`y[1, 2, 3, 1, Susyno`LieGroups`j, Susyno`LieGroups`k]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945812269987*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["63", "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945812322052*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945812322824*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`y[1, 3, 3, 1, Susyno`LieGroups`j, Susyno`LieGroups`k]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945812733664*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "k"}], "]"}]}], 
  "-", 
  RowBox[{
   FractionBox["63", "2"], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458127790003`*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458127808943`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`mu[1, 1, 1]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945813227174*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "18"}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945813287018*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945813288146*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`h[1, 2, 2, 1, Susyno`LieGroups`j, Susyno`LieGroups`k]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945813804551*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["63", "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"63", " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"M", "[", "1", "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "k", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458138632174`*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945813864025*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`h[1, 2, 3, 1, Susyno`LieGroups`j, Susyno`LieGroups`k]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945814341833*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["63", "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"12", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"63", " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"M", "[", "1", "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"12", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945814409438*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945814410205*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`h[1, 3, 3, 1, Susyno`LieGroups`j, Susyno`LieGroups`k]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945814950008*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["63", "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"63", " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"M", "[", "1", "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"3", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
   " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458150170393`*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945815018383*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   Susyno`LieGroups`b[1, 1, 1]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945815572934*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "18"}], " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
  RowBox[{"64", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
  RowBox[{"64", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
   " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
  RowBox[{"36", " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"M", "[", "1", "]"}], " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458156498547`*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945815652032*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`m2[1, 1, 1]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945816120412*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "-", 
  RowBox[{"36", " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"M", "[", "1", "]"}]}], "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"64", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "n", ",", "o"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "o"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "o"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "o"}], "]"}]}], 
  "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "o", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"32", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "n", ",", "o"}], "]"}]}], 
  "+", 
  RowBox[{"64", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "n", ",", "o"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945816194622*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945816197159*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`m2[2, 2, 1, Susyno`LieGroups`i, Susyno`LieGroups`j]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945816603889*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "-", 
  RowBox[{"45", " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"i", ",", "j"}], "]"}], " ", 
   RowBox[{"M", "[", "1", "]"}]}], "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945816676659*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945816679532*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`m2[2, 3, 1, Susyno`LieGroups`i, Susyno`LieGroups`j]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945817092699*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945817166757*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945817169813*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   SuperscriptBox["\[Beta]", "\<\"(1)\"\>"], 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}]}],
  SequenceForm[$CellContext`\[Beta]^"(1)", " of ", 
   $CellContext`m2[3, 3, 1, Susyno`LieGroups`i, Susyno`LieGroups`j]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.5679458175469027`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "i"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"h", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "-", 
  RowBox[{"45", " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"KroneckerDelta", "[", 
    RowBox[{"i", ",", "j"}], "]"}], " ", 
   RowBox[{"M", "[", "1", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "i"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "i"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "i"}], "]"}]}], 
  "+", 
  RowBox[{
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "n", ",", "i"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "m"}], "]"}]}], 
  "+", 
  RowBox[{"2", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"8", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}]}], 
  "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"y", "[", 
     RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], "]"}], 
    "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
    "]"}]}]}]], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945817615217*^9}],

Cell[BoxData["\<\"* * * * *\"\>"], "Print",
 CellChangeTimes->{
  3.567944732030506*^9, {3.5679447836679*^9, 3.5679448068082123`*^9}, 
   3.567944871629856*^9, 3.5679449018896646`*^9, 3.5679451043663*^9, 
   3.567945141000808*^9, {3.567945304704649*^9, 3.5679453292612743`*^9}, 
   3.567945817619627*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"g", "[", "1", "]"}], ",", 
     RowBox[{
      RowBox[{"-", "11"}], " ", 
      SuperscriptBox[
       RowBox[{"g", "[", "1", "]"}], "3"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"M", "[", "1", "]"}], ",", 
     RowBox[{
      RowBox[{"-", "22"}], " ", 
      SuperscriptBox[
       RowBox[{"g", "[", "1", "]"}], "2"], " ", 
      RowBox[{"M", "[", "1", "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["63", "2"]}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"k", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"k", ",", "n"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"k", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"k", ",", "n"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y2", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["63", "2"]}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "k"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "j"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "k"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"mu", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "18"}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"mu", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"mu", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"mu", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["63", "2"]}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"63", " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"M", "[", "1", "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"k", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"k", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"k", ",", "m"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "n"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"k", ",", "m"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"k", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"k", ",", "n"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"k", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "n"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"k", ",", "n"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h2", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["63", "2"]}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"12", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], 
        "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"n", ",", "k"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "k"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "n"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"63", " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"M", "[", "1", "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "n"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "k"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["63", "2"]}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], 
        "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], 
        "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], 
        "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "j"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"n", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "j"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}], 
        "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], 
        "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "k"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "j"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "k"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "18"}], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
      RowBox[{"64", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"mu", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"mu", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
      RowBox[{"36", " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"M", "[", "1", "]"}], " ", 
       RowBox[{"mu", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"b", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h", "[", 
         RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
         "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
        "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "-", 
      RowBox[{"36", " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"M", "[", "1", "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"64", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"n", ",", "o"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "o"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "o"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "o"}], "]"}]}], "+", 
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"o", ",", "n"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], ",", 
     RowBox[{
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "-", 
      RowBox[{"45", " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{"i", ",", "j"}], "]"}], " ", 
       RowBox[{"M", "[", "1", "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "m"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], ",", 
     RowBox[{
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h", "[", 
         RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], 
         "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], ",", 
     RowBox[{
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h", "[", 
         RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], 
         "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "m"}], 
        "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "-", 
      RowBox[{"45", " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{"i", ",", "j"}], "]"}], " ", 
       RowBox[{"M", "[", "1", "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "i"}], "]"}]}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.567945311579308*^9, 3.567945335937038*^9}, 
   3.567945817626142*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{"Simplify", "[", "%", "]"}]}]], "Input",
 CellChangeTimes->{{3.567945283353836*^9, 3.567945284996306*^9}, {
  3.567945343303697*^9, 3.567945343818338*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"g", "[", "1", "]"}], ",", 
     RowBox[{
      RowBox[{"-", "11"}], " ", 
      SuperscriptBox[
       RowBox[{"g", "[", "1", "]"}], "3"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"M", "[", "1", "]"}], ",", 
     RowBox[{
      RowBox[{"-", "22"}], " ", 
      SuperscriptBox[
       RowBox[{"g", "[", "1", "]"}], "2"], " ", 
      RowBox[{"M", "[", "1", "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Y", "[", 
              RowBox[{"j", ",", "n"}], "]"}], " ", 
             RowBox[{"Y", "[", 
              RowBox[{"k", ",", "m"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"Y", "[", 
              RowBox[{"j", ",", "m"}], "]"}], " ", 
             RowBox[{"Y", "[", 
              RowBox[{"k", ",", "n"}], "]"}]}]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Y", "[", 
              RowBox[{"k", ",", "m"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"j", ",", "n"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"Y", "[", 
              RowBox[{"j", ",", "m"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"k", ",", "n"}], "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["63", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
         RowBox[{"16", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}], "+", 
         RowBox[{"8", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y2", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["63", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
         RowBox[{"16", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}], "+", 
         RowBox[{"8", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"j", ",", "n"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "k"}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Y", "[", 
              RowBox[{"j", ",", "n"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"m", ",", "k"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"Y", "[", 
              RowBox[{"j", ",", "m"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"n", ",", "k"}], "]"}]}]}], ")"}]}]}], ")"}]}]}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      SqrtBox["10"], " ", 
      RowBox[{"Conjugate", "[", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Y2", "[", 
          RowBox[{"m", ",", "k"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"n", ",", "j"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"Y2", "[", 
          RowBox[{"m", ",", "j"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"n", ",", "k"}], "]"}]}]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"mu", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{
      FractionBox["2", "5"], " ", 
      RowBox[{"mu", "[", 
       RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "45"}], " ", 
         SuperscriptBox[
          RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
        RowBox[{"16", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}], "+", 
        RowBox[{"8", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{"16", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"63", " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"M", "[", "1", "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"k", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"k", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"8", " ", 
          RowBox[{"h", "[", 
           RowBox[{"m", ",", "n"}], "]"}], " ", 
          RowBox[{"Y", "[", 
           RowBox[{"j", ",", "k"}], "]"}]}], "+", 
         RowBox[{"5", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"h", "[", 
              RowBox[{"k", ",", "n"}], "]"}], " ", 
             RowBox[{"Y", "[", 
              RowBox[{"j", ",", "m"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"h", "[", 
              RowBox[{"k", ",", "m"}], "]"}], " ", 
             RowBox[{"Y", "[", 
              RowBox[{"j", ",", "n"}], "]"}]}], "+", 
            RowBox[{"2", " ", 
             RowBox[{"h", "[", 
              RowBox[{"j", ",", "n"}], "]"}], " ", 
             RowBox[{"Y", "[", 
              RowBox[{"k", ",", "m"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"h", "[", 
              RowBox[{"j", ",", "m"}], "]"}], " ", 
             RowBox[{"Y", "[", 
              RowBox[{"k", ",", "n"}], "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"k", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "n"}], "]"}]}], "+", 
      RowBox[{"3", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"k", ",", "n"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["63", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
         RowBox[{"16", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}], "+", 
         RowBox[{"8", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h2", "[", 
      RowBox[{"j", ",", "k"}], "]"}], ",", 
     RowBox[{
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"n", ",", "k"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "k"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"j", ",", "n"}], "]"}]}], "+", 
      RowBox[{"32", " ", 
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"63", " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"M", "[", "1", "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"j", ",", "k"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "k"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox[
        FractionBox["2", "5"]], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"60", " ", 
          RowBox[{"h", "[", 
           RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}], 
           "]"}], " ", 
          RowBox[{"Y", "[", 
           RowBox[{"j", ",", "m"}], "]"}]}], "+", 
         RowBox[{"16", " ", 
          RowBox[{"h2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"j", ",", "k"}], "]"}]}], "+", 
         RowBox[{"15", " ", 
          RowBox[{"h2", "[", 
           RowBox[{"m", ",", "k"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"j", ",", "n"}], "]"}]}], "+", 
         RowBox[{"15", " ", 
          RowBox[{"h2", "[", 
           RowBox[{"j", ",", "n"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "k"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"h2", "[", 
        RowBox[{"j", ",", "k"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["63", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
         RowBox[{"16", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}], "+", 
         RowBox[{"8", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"j", ",", "m"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "k"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], "]"}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "k"}], 
        "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["63", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"g", "[", "1", "]"}], "2"]}], "+", 
         RowBox[{"16", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}], "+", 
         RowBox[{"8", " ", 
          SqrtBox[
           FractionBox["2", "5"]], " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", 
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y2", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"h", "[", 
              RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "k", ",", "n"}],
               "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"m", ",", "j"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"h", "[", 
              RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "n"}],
               "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"m", ",", "k"}], "]"}]}]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"Conjugate", "[", 
           RowBox[{"Y", "[", 
            RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"h2", "[", 
              RowBox[{"n", ",", "k"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"m", ",", "j"}], "]"}]}], "+", 
            RowBox[{"2", " ", 
             RowBox[{"h2", "[", 
              RowBox[{"n", ",", "j"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"m", ",", "k"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"h2", "[", 
              RowBox[{"m", ",", "k"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"n", ",", "j"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"h2", "[", 
              RowBox[{"m", ",", "j"}], "]"}], " ", 
             RowBox[{"Y2", "[", 
              RowBox[{"n", ",", "k"}], "]"}]}]}], ")"}]}]}], ")"}]}]}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{
      FractionBox["1", "5"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "90"}], " ", 
         SuperscriptBox[
          RowBox[{"g", "[", "1", "]"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "[", 
            RowBox[{"1", ",", "1", ",", "1"}], "]"}], "-", 
           RowBox[{"2", " ", 
            RowBox[{"M", "[", "1", "]"}], " ", 
            RowBox[{"mu", "[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}]}]}], ")"}]}], "+", 
        RowBox[{"32", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"h", "[", 
             RowBox[{"m", ",", "n"}], "]"}], " ", 
            RowBox[{"mu", "[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"b", "[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
            RowBox[{"Y", "[", 
             RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}], "+", 
        RowBox[{"16", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"h2", "[", 
             RowBox[{"m", ",", "n"}], "]"}], " ", 
            RowBox[{"mu", "[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"b", "[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
            RowBox[{"Y2", "[", 
             RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{
      FractionBox["4", "5"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"8", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"h", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"h", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}], "+", 
        RowBox[{"8", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"h", "[", 
           RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
           "]"}], "]"}], " ", 
         RowBox[{"h", "[", 
          RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
          "]"}]}], "+", 
        RowBox[{"4", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"h2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"h2", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}], "-", 
        RowBox[{"45", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
         SuperscriptBox[
          RowBox[{"g", "[", "1", "]"}], "2"], " ", 
         RowBox[{"M", "[", "1", "]"}]}], "+", 
        RowBox[{"8", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}], "+", 
        RowBox[{"16", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"n", ",", "o"}], "]"}]}], "+", 
        RowBox[{"4", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}], "+", 
        RowBox[{"4", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "o"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"m", ",", "o"}], "]"}]}], "+", 
        RowBox[{"8", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"n", ",", "o"}], "]"}]}], "+", 
        RowBox[{"4", " ", 
         SqrtBox["10"], " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"o", ",", "n"}], "]"}]}]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], ",", 
     RowBox[{
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "-", 
      RowBox[{"45", " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{"i", ",", "j"}], "]"}], " ", 
       RowBox[{"M", "[", "1", "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "m"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"i", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"j", ",", "m"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "m"}], "]"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], ",", 
     RowBox[{
      SqrtBox["10"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"h2", "[", 
           RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
         RowBox[{"h", "[", 
          RowBox[{"i", ",", "m"}], "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"h", "[", 
           RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], 
           "]"}], "]"}], " ", 
         RowBox[{"h2", "[", 
          RowBox[{"i", ",", "m"}], "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"i", ",", "m"}], "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"i", ",", "m"}], "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"i", ",", "m"}], "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"i", ",", "n"}], "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "2", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
         RowBox[{"Y", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "j"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"i", ",", "n"}], "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"i", ",", "n"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"Conjugate", "[", 
          RowBox[{"Y2", "[", 
           RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
         RowBox[{"m2", "[", 
          RowBox[{"2", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
         RowBox[{"Y2", "[", 
          RowBox[{"m", ",", "n"}], "]"}]}]}], ")"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m2", "[", 
      RowBox[{"3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], ",", 
     RowBox[{
      RowBox[{"8", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h", "[", 
         RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "j", ",", "m"}], 
         "]"}], "]"}], " ", 
       RowBox[{"h", "[", 
        RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "m"}], 
        "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"h2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"h2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "-", 
      RowBox[{"45", " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
       SuperscriptBox[
        RowBox[{"g", "[", "1", "]"}], "2"], " ", 
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{"i", ",", "j"}], "]"}], " ", 
       RowBox[{"M", "[", "1", "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "j"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "i"}], "]"}]}], "+", 
      RowBox[{
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"3", ",", "3", ",", "1", ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"m", ",", "n"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SqrtBox["10"], " ", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Y2", "[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], " ", 
       RowBox[{"m2", "[", 
        RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"Y2", "[", 
        RowBox[{"n", ",", "i"}], "]"}]}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5679449085781918`*^9, 3.567945110979699*^9, 3.567945147438789*^9, {
   3.567945286096117*^9, 3.567945344186318*^9}, 3.5679458183544693`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Expand", "[", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"2", " ", "5"}], "]"}], 
    RowBox[{"res", "[", 
     RowBox[{"[", 
      RowBox[{"4", ",", "2"}], "]"}], "]"}]}], "]"}], " ", "/.", 
  RowBox[{
   RowBox[{"Y2", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], "\[Rule]", 
   RowBox[{
    RowBox[{"Y2", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"2", " ", "5"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.567945344742717*^9, 3.567945363291605*^9}, {
  3.567945446950844*^9, 3.567945447105472*^9}, {3.567945492782105*^9, 
  3.567945521298132*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["63", "2"]}], " ", 
   SuperscriptBox[
    RowBox[{"g", "[", "1", "]"}], "2"], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"j", ",", "k"}], "]"}]}], "+", 
  RowBox[{"16", " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"Y", "[", 
     RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
   RowBox[{"Y", "[", 
    RowBox[{"m", ",", "n"}], "]"}], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"j", ",", "k"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"Y", "[", 
     RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
   RowBox[{"Y", "[", 
    RowBox[{"j", ",", "n"}], "]"}], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"m", ",", "k"}], "]"}]}], "+", 
  RowBox[{
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"Y2", "[", 
     RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"j", ",", "n"}], "]"}], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"m", ",", "k"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["4", "5"], " ", 
   SqrtBox[
    FractionBox["2", "5"]], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"Y2", "[", 
     RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"j", ",", "k"}], "]"}], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"m", ",", "n"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   SqrtBox["10"], " ", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"Y", "[", 
     RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
   RowBox[{"Y", "[", 
    RowBox[{"j", ",", "m"}], "]"}], " ", 
   RowBox[{"Y2", "[", 
    RowBox[{"n", ",", "k"}], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.5679453462760363`*^9, 3.5679453637874327`*^9}, 
   3.56794544745261*^9, {3.567945504449669*^9, 3.5679455232197123`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Expand", "[", 
      RowBox[{"res", "[", 
       RowBox[{"[", "11", "]"}], "]"}], "]"}], " ", "/.", 
     RowBox[{
      RowBox[{"Y", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"Y", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "/", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"2", " ", "5"}], "]"}], "]"}]}]}]}], "/.", 
    RowBox[{
     RowBox[{"Y2", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{"Y2", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"2", " ", "5"}], "]"}], "]"}]}]}]}], "/.", 
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{"a_", ",", "b_"}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"h", "[", 
      RowBox[{"a", ",", "b"}], "]"}], "/", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"2", " ", "5"}], "]"}], "]"}]}]}]}], "/.", 
  RowBox[{
   RowBox[{"h2", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], "\[Rule]", 
   RowBox[{
    RowBox[{"h2", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"2", " ", "5"}], "]"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.567945556430098*^9, 3.567945611208112*^9}, 
   3.567945674099897*^9, {3.5679457089237947`*^9, 3.567945751556884*^9}, {
   3.567945783687724*^9, 3.567945784209846*^9}, {3.5679458239088087`*^9, 
   3.56794583414919*^9}, {3.567945868884478*^9, 3.5679458775256023`*^9}, {
   3.567945913734131*^9, 3.567945921048704*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     FractionBox["32", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"h", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"h", "[", 
      RowBox[{"m", ",", "n"}], "]"}]}], "+", 
    RowBox[{"32", " ", 
     SqrtBox[
      FractionBox["2", "5"]], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"h", "[", 
       RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], "]"}],
       "]"}], " ", 
     RowBox[{"h", "[", 
      RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "m", ",", "n"}], 
      "]"}]}], "+", 
    RowBox[{
     FractionBox["16", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"h2", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"h2", "[", 
      RowBox[{"m", ",", "n"}], "]"}]}], "-", 
    RowBox[{"36", " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"M", "[", "1", "]"}], "]"}], " ", 
     SuperscriptBox[
      RowBox[{"g", "[", "1", "]"}], "2"], " ", 
     RowBox[{"M", "[", "1", "]"}]}], "+", 
    RowBox[{
     FractionBox["32", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"Y", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"m2", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
     RowBox[{"Y", "[", 
      RowBox[{"m", ",", "n"}], "]"}]}], "+", 
    RowBox[{
     FractionBox["64", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"Y", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"m2", "[", 
      RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
     RowBox[{"Y", "[", 
      RowBox[{"n", ",", "o"}], "]"}]}], "+", 
    RowBox[{
     FractionBox["16", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"Y2", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"m2", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
     RowBox[{"Y2", "[", 
      RowBox[{"m", ",", "n"}], "]"}]}], "+", 
    RowBox[{
     FractionBox["16", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"Y2", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"m2", "[", 
      RowBox[{"3", ",", "3", ",", "1", ",", "n", ",", "o"}], "]"}], " ", 
     RowBox[{"Y2", "[", 
      RowBox[{"m", ",", "o"}], "]"}]}], "+", 
    RowBox[{
     FractionBox["32", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"Y", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"m2", "[", 
      RowBox[{"2", ",", "3", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
     RowBox[{"Y2", "[", 
      RowBox[{"n", ",", "o"}], "]"}]}], "+", 
    RowBox[{
     FractionBox["16", "5"], " ", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"Y2", "[", 
       RowBox[{"m", ",", "n"}], "]"}], "]"}], " ", 
     RowBox[{"m2", "[", 
      RowBox[{"2", ",", "2", ",", "1", ",", "m", ",", "o"}], "]"}], " ", 
     RowBox[{"Y2", "[", 
      RowBox[{"o", ",", "n"}], "]"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.567945613341957*^9, 3.567945674463963*^9, {3.567945712504222*^9, 
   3.567945752101406*^9}, 3.567945784545496*^9, 3.567945834677985*^9, {
   3.567945869252989*^9, 3.567945878293962*^9}, {3.567945915809149*^9, 
   3.567945921399263*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"10", "*", "16", "*", "10"}]], "Input",
 CellChangeTimes->{{3.5679460627637*^9, 3.567946067968121*^9}}],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{3.5679460638486443`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ShowLagrangian", "[", 
  RowBox[{"{", 
   RowBox[{"rep10", ",", "rep16", ",", "rep16A"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.567946431476863*^9, 3.567946455811706*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\">>>>>> Each rep/field is named Fld[<rep index>][<gauge \
indexes>,<flav if any>] <<<<<<\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.5679464650200043`*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465026976*^9}}],

Cell[BoxData["\<\"Y part:\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465027746*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["2", "5"], ")"}], 
     RowBox[{"1", "/", "4"}]]}], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"y", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}]}]], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465059721*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465090445*^9}}],

Cell[BoxData["\<\"\[Mu] part:\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465092043*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"mu", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}]}]}]], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465095088*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.5679464650986023`*^9}}],

Cell[BoxData["\<\"L part:\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465100486*^9}}],

Cell[BoxData["0"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465102512*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465104261*^9}}],

Cell[BoxData["\<\"H part:\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465106072*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["2", "5"], ")"}], 
     RowBox[{"1", "/", "4"}]]}], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "i"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "2", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["2", "5"], ")"}], 
    RowBox[{"1", "/", "4"}]], " ", 
   RowBox[{"h", "[", 
    RowBox[{"1", ",", "3", ",", "3", ",", "1", ",", "i", ",", "j"}], "]"}], 
   " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}]}]], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465140313*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.567946465168291*^9}}],

Cell[BoxData["\<\"B part:\"\>"], "Print",
 CellChangeTimes->{{3.5679464351696377`*^9, 3.56794646516908*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"b", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}]}]}]], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.567946465170054*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.567946465171117*^9}],

Cell[BoxData["\<\"S part:\"\>"], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.56794646517176*^9}],

Cell[BoxData["0"], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.567946465172304*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.567946465172914*^9}],

Cell[BoxData["\<\"M2 part:\"\>"], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.56794646517351*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "1", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "2", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "3", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "4", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "5", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "6", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "7", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "8", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "9", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "1", "]"}], "[", "10", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"1", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"1", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"2", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"2", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"3", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"3", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"4", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"4", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"5", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"5", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"6", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"6", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"7", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"7", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"8", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"8", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"9", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"9", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"10", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"10", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"11", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"11", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"12", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"12", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"13", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"13", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"14", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"14", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"15", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"15", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "2", "]"}], "[", 
     RowBox[{"16", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "2", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"16", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"2", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "2", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"1", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"1", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"2", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"2", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"3", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"3", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"4", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"4", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"5", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"5", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"6", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"6", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"7", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"7", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"8", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"8", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"9", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"9", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"10", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"10", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"11", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"11", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"12", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"12", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"13", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"13", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"14", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"14", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"15", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"15", ",", "j"}], "]"}]}], "+", 
  RowBox[{
   RowBox[{"Conjugate", "[", 
    RowBox[{
     RowBox[{"Fld", "[", "3", "]"}], "[", 
     RowBox[{"16", ",", "i"}], "]"}], "]"}], " ", 
   RowBox[{"m2", "[", 
    RowBox[{"3", ",", "3", ",", "1", ",", "j", ",", "i"}], "]"}], " ", 
   RowBox[{
    RowBox[{"Fld", "[", "3", "]"}], "[", 
    RowBox[{"16", ",", "j"}], "]"}]}]}]], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.567946465177248*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.567946465181786*^9}],

Cell[BoxData["\<\">>>>>>  End <<<<<<\"\>"], "Print",
 CellChangeTimes->{3.5679464351696377`*^9, 3.56794646518242*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"SparseArray", "[", 
     RowBox[{
      InterpretationBox[
       RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "960", 
        "\[InvisibleSpace]", "\<\">\"\>"}],
       SequenceForm["<", 960, ">"],
       Editable->False], ",", 
      RowBox[{"{", 
       RowBox[{"42", ",", "42", ",", "42"}], "}"}]}], "]"}],
    False,
    Editable->False], ",", 
   TagBox[
    RowBox[{"SparseArray", "[", 
     RowBox[{
      InterpretationBox[
       RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "10", 
        "\[InvisibleSpace]", "\<\">\"\>"}],
       SequenceForm["<", 10, ">"],
       Editable->False], ",", 
      RowBox[{"{", 
       RowBox[{"42", ",", "42"}], "}"}]}], "]"}],
    False,
    Editable->False], ",", 
   TagBox[
    RowBox[{"SparseArray", "[", 
     RowBox[{
      InterpretationBox[
       RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "0", 
        "\[InvisibleSpace]", "\<\">\"\>"}],
       SequenceForm["<", 0, ">"],
       Editable->False], ",", 
      RowBox[{"{", "42", "}"}]}], "]"}],
    False,
    Editable->False], ",", 
   TagBox[
    RowBox[{"SparseArray", "[", 
     RowBox[{
      InterpretationBox[
       RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "960", 
        "\[InvisibleSpace]", "\<\">\"\>"}],
       SequenceForm["<", 960, ">"],
       Editable->False], ",", 
      RowBox[{"{", 
       RowBox[{"42", ",", "42", ",", "42"}], "}"}]}], "]"}],
    False,
    Editable->False], ",", 
   TagBox[
    RowBox[{"SparseArray", "[", 
     RowBox[{
      InterpretationBox[
       RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "10", 
        "\[InvisibleSpace]", "\<\">\"\>"}],
       SequenceForm["<", 10, ">"],
       Editable->False], ",", 
      RowBox[{"{", 
       RowBox[{"42", ",", "42"}], "}"}]}], "]"}],
    False,
    Editable->False], ",", 
   TagBox[
    RowBox[{"SparseArray", "[", 
     RowBox[{
      InterpretationBox[
       RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "0", 
        "\[InvisibleSpace]", "\<\">\"\>"}],
       SequenceForm["<", 0, ">"],
       Editable->False], ",", 
      RowBox[{"{", "42", "}"}]}], "]"}],
    False,
    Editable->False], ",", 
   TagBox[
    RowBox[{"SparseArray", "[", 
     RowBox[{
      InterpretationBox[
       RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "58", 
        "\[InvisibleSpace]", "\<\">\"\>"}],
       SequenceForm["<", 58, ">"],
       Editable->False], ",", 
      RowBox[{"{", 
       RowBox[{"42", ",", "42"}], "}"}]}], "]"}],
    False,
    Editable->False]}], "}"}]], "Output",
 CellChangeTimes->{3.567946465183413*^9}]
}, Open  ]]
},
WindowSize->{1366, 693},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"8.0 for Linux x86 (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 116, 2, 30, "Input"],
Cell[698, 26, 1093, 23, 43, "Print"]
}, Open  ]],
Cell[1806, 52, 620, 18, 30, "Input"],
Cell[CellGroupData[{
Cell[2451, 74, 2839, 78, 126, "Input"],
Cell[CellGroupData[{
Cell[5315, 156, 556, 13, 23, "Print"],
Cell[5874, 171, 384, 9, 23, "Print"],
Cell[6261, 182, 304, 5, 23, "Print"],
Cell[6568, 189, 558, 13, 23, "Print"],
Cell[7129, 204, 419, 10, 23, "Print"],
Cell[7551, 216, 304, 5, 23, "Print"],
Cell[7858, 223, 667, 14, 23, "Print"],
Cell[8528, 239, 4268, 125, 184, "Print"],
Cell[12799, 366, 304, 5, 23, "Print"],
Cell[13106, 373, 667, 14, 23, "Print"],
Cell[13776, 389, 4288, 125, 197, "Print"],
Cell[18067, 516, 304, 5, 23, "Print"],
Cell[18374, 523, 667, 14, 23, "Print"],
Cell[19044, 539, 4250, 124, 201, "Print"],
Cell[23297, 665, 306, 5, 23, "Print"],
Cell[23606, 672, 596, 14, 23, "Print"],
Cell[24205, 688, 1675, 48, 103, "Print"],
Cell[25883, 738, 304, 5, 23, "Print"],
Cell[26190, 745, 667, 14, 23, "Print"],
Cell[26860, 761, 8264, 243, 333, "Print"],
Cell[35127, 1006, 304, 5, 23, "Print"],
Cell[35434, 1013, 667, 14, 23, "Print"],
Cell[36104, 1029, 8284, 243, 351, "Print"],
Cell[44391, 1274, 304, 5, 23, "Print"],
Cell[44698, 1281, 667, 14, 23, "Print"],
Cell[45368, 1297, 8264, 243, 364, "Print"],
Cell[53635, 1542, 304, 5, 23, "Print"],
Cell[53942, 1549, 598, 14, 23, "Print"],
Cell[54543, 1565, 3079, 90, 207, "Print"],
Cell[57625, 1657, 304, 5, 23, "Print"],
Cell[57932, 1664, 596, 14, 23, "Print"],
Cell[58531, 1680, 5192, 150, 363, "Print"],
Cell[63726, 1832, 304, 5, 23, "Print"],
Cell[64033, 1839, 656, 14, 23, "Print"],
Cell[64692, 1855, 5485, 153, 154, "Print"],
Cell[70180, 2010, 304, 5, 23, "Print"],
Cell[70487, 2017, 656, 14, 23, "Print"],
Cell[71146, 2033, 5997, 167, 175, "Print"],
Cell[77146, 2202, 304, 5, 23, "Print"],
Cell[77453, 2209, 658, 14, 23, "Print"],
Cell[78114, 2225, 5485, 153, 154, "Print"],
Cell[83602, 2380, 304, 5, 23, "Print"]
}, Open  ]],
Cell[83921, 2388, 34387, 979, 1468, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[118345, 3372, 201, 4, 30, "Input"],
Cell[118549, 3378, 33273, 929, 1245, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[151859, 4312, 641, 19, 30, "Input"],
Cell[152503, 4333, 1847, 59, 110, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[154387, 4397, 1662, 48, 50, "Input"],
Cell[156052, 4447, 3346, 94, 163, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[159435, 4546, 126, 2, 30, "Input"],
Cell[159564, 4550, 73, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[159674, 4556, 203, 4, 30, "Input"],
Cell[CellGroupData[{
Cell[159902, 4564, 191, 2, 23, "Print"],
Cell[160096, 4568, 102, 1, 23, "Print"],
Cell[160201, 4571, 109, 1, 23, "Print"],
Cell[160313, 4574, 118674, 3843, 4562, "Print"],
Cell[278990, 8419, 102, 1, 23, "Print"],
Cell[279095, 8422, 113, 1, 23, "Print"],
Cell[279211, 8425, 1298, 37, 43, "Print"],
Cell[280512, 8464, 104, 1, 23, "Print"],
Cell[280619, 8467, 109, 1, 23, "Print"],
Cell[280731, 8470, 95, 1, 23, "Print"],
Cell[280829, 8473, 102, 1, 23, "Print"],
Cell[280934, 8476, 109, 1, 23, "Print"],
Cell[281046, 8479, 118674, 3843, 4562, "Print"],
Cell[399723, 12324, 102, 1, 23, "Print"],
Cell[399828, 12327, 108, 1, 23, "Print"],
Cell[399939, 12330, 1291, 37, 43, "Print"],
Cell[401233, 12369, 100, 1, 23, "Print"],
Cell[401336, 12372, 106, 1, 23, "Print"],
Cell[401445, 12375, 93, 1, 23, "Print"],
Cell[401541, 12378, 100, 1, 23, "Print"],
Cell[401644, 12381, 107, 1, 23, "Print"],
Cell[401754, 12384, 19149, 562, 518, "Print"],
Cell[420906, 12948, 100, 1, 23, "Print"],
Cell[421009, 12951, 117, 1, 23, "Print"]
}, Open  ]],
Cell[421141, 12955, 2565, 85, 50, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
